pair(C,X) :- penalty(C,X,P).
clique(C) :- pair(C,X).
var(X)    :- pair(C,X).

:- in(C,X), not pair(C,X).
:- var(X), #count{C : in(C,X)} != 1.
:- clique(C), #count{X : in(C,X)} > 2.

triple(X,C,Y) :- member(X,C), var(X), in(C,Y), X != Y.

okin(C,X) :- in(C,X), ok(X).
ok(X)     :- var(X), okin(C,Y) : triple(X,C,Y).

:- var(X), not ok(X).

cliquesize(C,S) :- clique(C), S = #count{X : member(X,C)}, S != 0.

cno(C1,C2)    :- cliquesize(C1,S), cliquesize(C2,S+1), 1 < S.
cex(C1,C2)    :- cno(C1,C2), member(X,C1), not member(X,C2).
rest(C1,X,C2) :- member(X,C1), cno(C2,C1), not cex(C2,C1).

aux(R,Y) :- in(R,Y), not cliquesize(R,1).
aux(R,Y) :- aux(C,Y), rest(C,X,R).

:- in(C,X), rest(C,X,R), not aux(R,Y) : member(Y,R).

:~ in(C,X), penalty(C,X,P). [P,X]
